;==============================================================================

;------------------------------------------------
; This is the MASM32 chr$ macro with no changes.
;------------------------------------------------

chr$ MACRO any_text:VARARG
  LOCAL txtname
  .data
    txtname db any_text,0
  .code
  EXITM <OFFSET txtname>
ENDM

;==============================================================================

;-------------------------------------------------------------------
; This is the MASM32 cfm$ macro with the characters substituted for
; the newline escape changed from CRLF to LF.
;-------------------------------------------------------------------

; ********************************************************
; format a C style string complete with escape characters
; and return the offset of the result to the calling macro
; ********************************************************
cfm$ MACRO txt:VARARG                       ;; format C style string
  LOCAL buffer,lbuf,rbuf,sln,flag1,tmp,notq
    flag1 = 0
    notq  = 0
    buffer equ <>
    lbuf equ <>
    rbuf equ <>
  FORC char,<txt>
    IFDIF <char>,<">              ;; test if 1st char is a quote
      notq = 1
      EXITM                       ;; exit with notq set to 1 if its not
    ENDIF
    EXITM                         ;; else exit with notq set to 0
  ENDM
  IF notq EQ 1
    EXITM <txt>                   ;; return original arg if its not a quote
  ENDIF
  FORC char,<txt>
    IF flag1 NE 0   ;; process characters preceded by the escape character
      IFIDN <char>,<n>
        buffer CATSTR buffer,<",10,">    ;; \n = newline
        flag1 = 0
        goto lpend
      ENDIF
      IFIDN <char>,<t>
        buffer CATSTR buffer,<",9,">        ;; \t = tab
        flag1 = 0
        goto lpend
      ENDIF
      IFIDN <char>,<\>
        buffer CATSTR buffer,<\>            ;; \\ = \
        flag1 = 0
        goto lpend
      ENDIF
      IFIDN <char>,<q>
        buffer CATSTR buffer,<",34,">       ;; \q = quote
        flag1 = 0
        goto lpend
      ENDIF
   ;; ---------------------
   ;; masm specific escapes
   ;; ---------------------
      IFIDN <char>,<l>
        buffer CATSTR buffer,<",60,">       ;; \l = <
        flag1 = 0
        goto lpend
      ENDIF
      IFIDN <char>,<r>
        buffer CATSTR buffer,<",62,">       ;; \r = >
        flag1 = 0
        goto lpend
      ENDIF
      IFIDN <char>,<x>
        buffer CATSTR buffer,<",33,">       ;; \x = !
        flag1 = 0
        goto lpend
      ENDIF
      IFIDN <char>,<a>
        buffer CATSTR buffer,<",40,">       ;; \a = (
        flag1 = 0
        goto lpend
      ENDIF
      IFIDN <char>,<b>
      buffer CATSTR buffer,<",41,">       ;; \b = )
      flag1 = 0
      goto lpend
      ENDIF
    ENDIF
    IFIDN <char>,<\>      ;; trap the escape character and set the flag
      flag1 = 1
      goto lpend
    ENDIF
    buffer CATSTR buffer,<char>
  :lpend
  ENDM
;; ---------------------------------------------
;; strip any embedded <"",> characters sequences
;; ---------------------------------------------
    buffer CATSTR buffer,<,0,0,0>     ;; append trailing zeros
    cpos INSTR buffer,<"",>           ;; test for leading junk
    IF cpos EQ 1
      buffer SUBSTR buffer,4          ;; chomp off any leading junk
    ENDIF
  :reloop
    cpos INSTR buffer,<"",>
    IF cpos EQ 0                    ;; if no junk left
      goto done                     ;; exit the loop
    ENDIF
    lbuf SUBSTR buffer,1,cpos-1       ;; read text before junk
    rbuf SUBSTR buffer,cpos+3         ;; read text after junk
    buffer equ <>                     ;; clear the buffer
    buffer CATSTR lbuf,rbuf           ;; concantenate the two
    goto reloop                       ;; loop back and try again
  :done
    sln SIZESTR buffer
    buffer SUBSTR buffer,1,sln-4      ;; trim off tail padding
    .data
      tmp db buffer                   ;; write result to DATA section
    .code
    EXITM <OFFSET tmp>                ;; return the DATA section OFFSET
ENDM

;==============================================================================

print MACRO format:REQ, args:VARARG
    IFNB <args>
        invoke cprintf_, cfm$(format), args
    ELSE
        invoke cprintf_, cfm$(format)
    ENDIF
ENDM

;==============================================================================

;----------------------------------------------------------------------
; This  macro implements a 16-bit version of the Watcom register-based
; parameter passing convention, which is the default for all but the
; variadic (VARARG) functions, and functions that take floating-point
; parameters. As currently coded it can handle only 8 parameters.
;----------------------------------------------------------------------

watcall MACRO func:REQ,p1,p2,p3,p4,p5,p6,p7,p8
  IFNB <p8>
      push p8
  ENDIF
  IFNB <p7>
      push p7
  ENDIF
  IFNB <p6>
      push p6
  ENDIF
  IFNB <p5>
      push p5
  ENDIF
  IFNB <p4>
      mov cx, p4
  ENDIF
  IFNB <p3>
      mov bx, p3
  ENDIF
  IFNB <p2>
      mov dx, p2
  ENDIF
  IFNB <p1>
      mov ax, p1
  ENDIF
  call func
ENDM

;==============================================================================
