;==============================================================================
.model small, C
option casemap:none
.386
include macros.asm
;==============================================================================

cprintf_    PROTO SYSCALL :VARARG
rand_       PROTO SYSCALL
getch_      PROTO SYSCALL
qsort_      PROTO SYSCALL
strcmp_     PROTO SYSCALL
strtok_     PROTO SYSCALL
malloc_     PROTO SYSCALL
free_       PROTO SYSCALL
_gcvt_      PROTO SYSCALL :REAL8,:WORD,:WORD
atan_       PROTO SYSCALL :REAL8

;==============================================================================
.stack
.data
    array   dw 100 dup(0)
    str1    db "my other brother darryl",0
    str2    db "my other brother",0
.code
;==============================================================================

;-----------------------------------------------
; This dummy procedure prevents the linker from
; returning an "unresolved external" error.
;-----------------------------------------------

main_ proc SYSCALL
    ret
main_ endp

;==============================================================================

;------------------------------
; Compare procedure for qsort.
;------------------------------

compare proc SYSCALL
    push si
    push di
    mov si, ax
    mov di, dx
    mov ax, [si]
    sub ax, [di]
    pop di
    pop si
    ret
compare endp

;==============================================================================
.startup
;==============================================================================

    print "load static array with random values:\n"
    invoke getch_

    mov si, OFFSET array
    xor bx, bx
    .WHILE bx < 200
        invoke rand_
        mov [si+bx], ax
        add bx, 2
    .ENDW

    xor bx, bx
    .WHILE bx < 200
        mov ax, [si+bx]
        print "%d\t", ax
        add bx, 2
    .ENDW

    print "qsort static array:\n"
    invoke getch_

    watcall qsort_, OFFSET array, 100, 2, compare

    mov si, OFFSET array
    xor bx, bx
    .WHILE bx < 200
        mov ax, [si+bx]
        print "%d\t", ax
        add bx, 2
    .ENDW

    print "allocate array:\n"
    invoke getch_

    ;------------------------------
    ; Pointers are returned in si.
    ;------------------------------

    watcall malloc_, 20000
    print "%d\n", si

    print "load allocated array with random values:\n"
    invoke getch_

    xor bx, bx
    .WHILE bx < 200
        invoke rand_
        mov [si+bx], ax
        add bx, 2
    .ENDW

    xor bx, bx
    .WHILE bx < 200
        mov ax, [si+bx]
        print "%d\t", ax
        add bx, 2
    .ENDW

    print "qsort allocated array:\n"
    invoke getch_

    watcall qsort_, si, 100, 2, compare

    xor bx, bx
    .WHILE bx < SIZEOF array
        mov ax, [si+bx]
        print "%d\t", ax
        add bx, 2
    .ENDW

    watcall free_, si

    print "strcmp:\n"
    invoke getch_

    print "%s\n", ADDR str1
    print "%s\n", ADDR str2
    watcall strcmp_, OFFSET str1, OFFSET str2
    print "%d\n", ax
    watcall strcmp_, OFFSET str2, OFFSET str1
    print "%d\n", ax
    watcall strcmp_, OFFSET str1, OFFSET str1
    print "%d\n", ax

    print "strtok:\n"
    invoke getch_

    watcall strtok_, OFFSET str1, chr$(" ",0)
    .WHILE ax
        print "%s\n", ax
        watcall strtok_, 0, chr$(" ",0)
    .ENDW

    print "convert pi to string:\n"
    invoke getch_

    .data
        r8     REAL8 ?
        four   REAL8 4.0
        buffer db 30 dup(0)
    .code

    fldpi
    fstp r8

    comment|
    push OFFSET buffer
    push 10
    push WORD PTR r8+6
    push WORD PTR r8+4
    push WORD PTR r8+2
    push WORD PTR r8
    call _gcvt_
    |
    invoke _gcvt_, r8, 10, ADDR buffer
    print "%s\n", ax

    print "derive pi from atan:\n"
    invoke getch_

    ;----------------------------------------
    ; Floating-point results are returned at
    ; the top of the FPU stack in ST(0)
    ;----------------------------------------

    fld1
    fstp r8
    invoke atan_, r8
    fld four
    fmul
    fstp r8
    invoke _gcvt_, r8, 10, ADDR buffer
    print "%s\n", ax

    print "attempt to printf a floating-point value:\n"
    invoke getch_

    ;-------------------------------------------------------------------
    ; Unfortunately, this will still return "Floating-point support not
    ; loaded", and the program will exit without pausing at getch.
    ;-------------------------------------------------------------------

    print "%f\n", r8

    print "never get here\n"

    invoke getch_

;==============================================================================
.exit
end
